<?php
    if ( isset( $_POST['mrstk_favico'] ) )
    {
        update_option( 'mrstk-favico', $_POST['mrstk_favico'] );

        $this->rewrite_update( $_POST['mrstk_favico'] );
    }

    $url = get_option( 'mrstk-favico', '' );
?>
<div class="wrap">
    <h2>favicon.ico</h2>

    <h3>Main settings</h3>
    Supply the link to your fav.ico file, or you may use the media browser to upload it on your own.
    <br /><br/>

    <form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
        <input id="mrstk_favico_address" name="mrstk_favico" size="40" type="text" value="<?php echo $url; ?>" />
        <input class="button" name="mrstk_favico_address_button" id="mrstk_favico_address_button" value="Upload" />

        <?php submit_button() ?>
    </form>
</div>

<script type="text/javascript">
    jQuery(document).ready(function($){

        var _custom_media = true,
            _orig_send_attachment = wp.media.editor.send.attachment;

        $('#mrstk_favico_address_button').click(function(e) {
            var send_attachment_bkp = wp.media.editor.send.attachment;
            var button = $(this);
            var id = button.attr('id').replace('_button', '');
            _custom_media = true;
            wp.media.editor.send.attachment = function(props, attachment){
                if ( _custom_media ) {
                    $("#" + id).val(attachment.url);
                } else {
                    return _orig_send_attachment.apply( this, [props, attachment] );
                }
            };
            wp.media.editor.open(button);
            return false;
        });
        $('.add_media').on('click', function(){
            _custom_media = false;
        });
    });
</script>